#if (defined(_WIN32) || defined(__MINGW32__))

#include "HsWinError.h"
#include <windows.h>

LPWSTR GetErrorMessageW(DWORD dwError)
{
    LPWSTR lpMsgBuf = NULL;
    DWORD res;

    res = FormatMessageW(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |  /* free buffer with LocalFree */
        FORMAT_MESSAGE_FROM_SYSTEM     |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dwError,
        0,
        (LPWSTR)&lpMsgBuf,
        0,
        NULL);
    if (res == 0) {
        lpMsgBuf = (LPWSTR) L"[No description available]";
    }
    return lpMsgBuf;
}

HANDLE invalidHandleValue(void) {return INVALID_HANDLE_VALUE;}

#endif
